diff --git a/src/effect-handler-general.c b/src/effect-handler-general.c
index ece70d14f7..cd2f1bdec5 100644
--- a/src/effect-handler-general.c
+++ b/src/effect-handler-general.c
@@ -1766,7 +1766,7 @@ static bool detect_monsters(int y_dist, int x_dist, monster_predicate pred)
 				player->upkeep->redraw |= (PR_MONSTER);
 
 			/* Update the monster */
-			update_mon(mon, cave, false);
+			update_mon(player, mon, cave, false);
 
 			/* Detect */
 			monsters = true;
diff --git a/src/game-world.c b/src/game-world.c
index 4c62d08090..a2a1766691 100644
--- a/src/game-world.c
+++ b/src/game-world.c
@@ -944,7 +944,8 @@ static void process_player_cleanup(void)
 				if (mflag_has(mon->mflag, MFLAG_MARK)) {
 					if (!mflag_has(mon->mflag, MFLAG_SHOW)) {
 						mflag_off(mon->mflag, MFLAG_MARK);
-						update_mon(mon, cave, false);
+						update_mon(player, mon, cave,
+							false);
 					}
 				}
 			}
diff --git a/src/gen-cave.c b/src/gen-cave.c
index ac2969868f..a000d1484b 100644
--- a/src/gen-cave.c
+++ b/src/gen-cave.c
@@ -4063,7 +4063,7 @@ struct chunk *arena_gen(struct player *p, int min_height, int min_width) {
 	c->mon_max = mon->midx + 1;
 	c->mon_cnt = 1;
 	mon->target.midx = -1; /* Careful... */
-	update_mon(mon, c, true);
+	update_mon(p, mon, c, true);
 	p->upkeep->health_who = mon;
 
 	/* Ignore its held objects */
diff --git a/src/mon-make.c b/src/mon-make.c
index d03e3ef42b..d1fd1f7e7e 100644
--- a/src/mon-make.c
+++ b/src/mon-make.c
@@ -1725,7 +1725,7 @@ s16b place_monster(struct chunk *c, struct loc grid, struct monster *mon,
 	/* Assign monster to its monster group, or update its entry */
 	monster_group_assign(c, new_mon, info, loading);
 
-	update_mon(new_mon, c, true);
+	update_mon(player, new_mon, c, true);
 
 	/* Count the number of "reproducers" */
 	if (rf_has(new_mon->race->flags, RF_MULTIPLY)) c->num_repro++;
diff --git a/src/mon-util.c b/src/mon-util.c
index 46a00a42ea..a43f13d235 100644
--- a/src/mon-util.c
+++ b/src/mon-util.c
@@ -306,14 +306,15 @@ static void path_analyse(struct chunk *c, struct loc grid)
  * "OPT(player, disturb_near)" (monster which is "easily" viewable moves in some
  * way).  Note that "moves" includes "appears" and "disappears".
  */
-void update_mon(struct monster *mon, struct chunk *c, bool full)
+void update_mon(struct player *p, struct monster *mon, struct chunk *c,
+		bool full)
 {
 	struct monster_lore *lore;
 
 	int d;
 
 	/* If still generating the level, measure distances from the middle */
-	struct loc pgrid = character_dungeon ? player->grid :
+	struct loc pgrid = character_dungeon ? p->grid :
 		loc(c->width / 2, c->height / 2);
 
 	/* Seen at all */
@@ -323,7 +324,7 @@ void update_mon(struct monster *mon, struct chunk *c, bool full)
 	bool easy = false;
 
 	/* ESP permitted */
-	bool telepathy_ok = player_of_has(player, OF_TELEPATHY);
+	bool telepathy_ok = player_of_has(p, OF_TELEPATHY);
 
 	/* Themed level */
 	bool themed = player->themed_level ? true : false;
@@ -391,9 +392,9 @@ void update_mon(struct monster *mon, struct chunk *c, bool full)
 		}
 
 		/* Normal line of sight and player is not blind */
-		if (square_isview(c, mon->grid) && !player->timed[TMD_BLIND]) {
+		if (square_isview(c, mon->grid) && !p->timed[TMD_BLIND]) {
 			/* Use "infravision" */
-			if (d <= player->state.see_infra) {
+			if (d <= p->state.see_infra) {
 				/* Learn about warm/cold blood */
 				rf_on(lore->flags, RF_COLD_BLOOD);
 
@@ -412,7 +413,7 @@ void update_mon(struct monster *mon, struct chunk *c, bool full)
 				/* Handle invisibility */
 				if (monster_is_invisible(mon)) {
 					/* See invisible */
-					if (player_of_has(player, OF_SEE_INVIS)) {
+					if (player_of_has(p, OF_SEE_INVIS)) {
 						/* Easy to see */
 						easy = flag = true;
 					}
@@ -430,7 +431,7 @@ void update_mon(struct monster *mon, struct chunk *c, bool full)
 	/* If a mimic looks like an ignored item, it's not seen */
 	if (monster_is_mimicking(mon)) {
 		struct object *obj = mon->mimicked_obj;
-		if (ignore_item_ok(player, obj))
+		if (ignore_item_ok(p, obj))
 			easy = flag = false;
 	}
 
@@ -451,20 +452,20 @@ void update_mon(struct monster *mon, struct chunk *c, bool full)
 			square_light_spot(c, mon->grid);
 
 			/* Update health bar as needed */
-			if (player->upkeep->health_who == mon)
-				player->upkeep->redraw |= (PR_HEALTH);
+			if (p->upkeep->health_who == mon)
+				p->upkeep->redraw |= (PR_HEALTH);
 
 			/* Hack -- Count "fresh" sightings */
 			if (lore->sights < SHRT_MAX)
 				lore->sights++;
 
 			/* Window stuff */
-			player->upkeep->redraw |= PR_MONLIST;
+			p->upkeep->redraw |= PR_MONLIST;
 		}
 	} else if (monster_is_visible(mon)) {
 		/* Not visible but was previously seen - treat mimics differently */
 		if (!mon->mimicked_obj
-				|| ignore_item_ok(player, mon->mimicked_obj)) {
+				|| ignore_item_ok(p, mon->mimicked_obj)) {
 			/* Mark as not visible */
 			mflag_off(mon->mflag, MFLAG_VISIBLE);
 
@@ -472,11 +473,11 @@ void update_mon(struct monster *mon, struct chunk *c, bool full)
 			square_light_spot(c, mon->grid);
 
 			/* Update health bar as needed */
-			if (player->upkeep->health_who == mon)
-				player->upkeep->redraw |= (PR_HEALTH);
+			if (p->upkeep->health_who == mon)
+				p->upkeep->redraw |= (PR_HEALTH);
 
 			/* Window stuff */
-			player->upkeep->redraw |= PR_MONLIST;
+			p->upkeep->redraw |= PR_MONLIST;
 		}
 	}
 
@@ -489,11 +490,11 @@ void update_mon(struct monster *mon, struct chunk *c, bool full)
 			mflag_on(mon->mflag, MFLAG_VIEW);
 
 			/* Disturb on appearance */
-			if (OPT(player, disturb_near))
-				disturb(player);
+			if (OPT(p, disturb_near))
+				disturb(p);
 
 			/* Re-draw monster window */
-			player->upkeep->redraw |= PR_MONLIST;
+			p->upkeep->redraw |= PR_MONLIST;
 		}
 	} else {
 		/* Change */
@@ -502,11 +503,11 @@ void update_mon(struct monster *mon, struct chunk *c, bool full)
 			mflag_off(mon->mflag, MFLAG_VIEW);
 
 			/* Disturb on disappearance */
-			if (OPT(player, disturb_near) && !monster_is_mimicking(mon))
-				disturb(player);
+			if (OPT(p, disturb_near) && !monster_is_mimicking(mon))
+				disturb(p);
 
 			/* Re-draw monster list window */
-			player->upkeep->redraw |= PR_MONLIST;
+			p->upkeep->redraw |= PR_MONLIST;
 		}
 	}
 }
@@ -514,7 +515,7 @@ void update_mon(struct monster *mon, struct chunk *c, bool full)
 /**
  * Updates all the (non-dead) monsters via update_mon().
  */
-void update_monsters(bool full)
+void update_monsters(struct player *p, bool full)
 {
 	int i;
 
@@ -524,7 +525,7 @@ void update_monsters(bool full)
 
 		/* Update the monster if alive */
 		if (mon->race)
-			update_mon(mon, cave, full);
+			update_mon(p, mon, cave, full);
 	}
 }
 
@@ -633,7 +634,7 @@ void monster_swap(struct loc grid1, struct loc grid2)
 			}
 		}
 		mon->grid = grid2;
-		update_mon(mon, cave, true);
+		update_mon(player, mon, cave, true);
 
 		/* Affect light? */
 		if (mon->race->light != 0)
@@ -682,7 +683,7 @@ void monster_swap(struct loc grid1, struct loc grid2)
 			}
 		}
 		mon->grid = grid1;
-		update_mon(mon, cave, true);
+		update_mon(player, mon, cave, true);
 
 		/* Affect light? */
 		if (mon->race->light != 0)
@@ -803,7 +804,7 @@ void become_aware(struct chunk *c, struct monster *mon, struct player *p)
 			square_delete_object(c, obj->grid, obj, false, false);
 
 			/* Since mimicry affects visibility, update that. */
-			update_mon(mon, c, false);
+			update_mon(p, mon, c, false);
 		}
 
 		/* Update monster and item lists */
@@ -1377,7 +1378,7 @@ void kill_arena_monster(struct monster *mon)
 {
 	struct monster *old_mon = cave_monster(cave, mon->midx);
 	assert(old_mon);
-	update_mon(old_mon, cave, true);
+	update_mon(player, old_mon, cave, true);
 	old_mon->hp = -1;
 	player_kill_monster(old_mon, player, " is defeated!");
 }
diff --git a/src/mon-util.h b/src/mon-util.h
index 2f752639ac..3c524f6f1e 100644
--- a/src/mon-util.h
+++ b/src/mon-util.h
@@ -28,8 +28,9 @@ struct monster_race *lookup_monster(const char *name);
 struct monster_base *lookup_monster_base(const char *name);
 struct blow_effect *lookup_monster_blow_effect(const char *eff_name);
 bool match_monster_bases(const struct monster_base *base, ...);
-void update_mon(struct monster *mon, struct chunk *c, bool full);
-void update_monsters(bool full);
+void update_mon(struct player *p, struct monster *mon, struct chunk *c,
+	bool full);
+void update_monsters(struct player *p, bool full);
 bool monster_carry(struct chunk *c, struct monster *mon, struct object *obj);
 void monster_swap(struct loc grid1, struct loc grid2);
 void monster_wake(struct monster *mon, bool notify, int aware_chance);
diff --git a/src/player-calcs.c b/src/player-calcs.c
index 033b15dd44..74f316db6d 100644
--- a/src/player-calcs.c
+++ b/src/player-calcs.c
@@ -3017,12 +3017,12 @@ void update_stuff(struct player *p)
 	if (p->upkeep->update & (PU_DISTANCE)) {
 		p->upkeep->update &= ~(PU_DISTANCE);
 		p->upkeep->update &= ~(PU_MONSTERS);
-		update_monsters(true);
+		update_monsters(p, true);
 	}
 
 	if (p->upkeep->update & (PU_MONSTERS)) {
 		p->upkeep->update &= ~(PU_MONSTERS);
-		update_monsters(false);
+		update_monsters(p, false);
 	}
 
 
diff --git a/src/project-mon.c b/src/project-mon.c
index 043a0b1a24..43b95e2ffe 100644
--- a/src/project-mon.c
+++ b/src/project-mon.c
@@ -1585,7 +1585,7 @@ void project_m(struct source origin, int r, struct loc grid, int dam, int typ,
 	if (mon != NULL) {
 		/* Update the monster */
 		if (!mon_died) {
-			update_mon(mon, cave, false);
+			update_mon(player, mon, cave, false);
 
 			/* Become hostile (to the player only, for now) */
 			if (origin.what == SRC_PLAYER) {
